package com.acabezas.ehealth_doctor_app.home.pacient_waiting_fragment;

import android.support.constraint.ConstraintLayout;
import android.support.v7.widget.RecyclerView;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.TextView;

import com.acabezas.ehealth_doctor_app.R;
import com.acabezas.ehealth_doctor_app.core.StartVideoConferenceCallback;
import com.acabezas.ehealth_doctor_sdk.model.PacientWaiting;

import java.util.List;

/**
 * Created by alexandercabezas on 12/5/18.
 */

public class PacientWaitListAdapter  extends RecyclerView.Adapter<PacientWaitListAdapter.ViewHolder>{

    private List<PacientWaiting> dataSet;
    private StartVideoConferenceCallback callback;

    public static class ViewHolder extends RecyclerView.ViewHolder {
        // each data item is just a string in this case
        public TextView id;
        public TextView name;
        public ConstraintLayout container;

        public ViewHolder(View view) {
            super(view);
            id = (TextView) view.findViewById(R.id.identifier);
            name = (TextView) view.findViewById(R.id.name);
            container = (ConstraintLayout) view.findViewById(R.id.container);
        }
    }

    public PacientWaitListAdapter(List<PacientWaiting> dataSet, StartVideoConferenceCallback callback) {
        this.dataSet = dataSet;
        this.callback = callback;
    }

    @Override
    public PacientWaitListAdapter.ViewHolder onCreateViewHolder(ViewGroup parent, int viewType) {
        View itemView = LayoutInflater.from(parent.getContext())
                .inflate(R.layout.pacient_wait_row, parent, false);

        return new PacientWaitListAdapter.ViewHolder(itemView);
    }

    @Override
    public void onBindViewHolder(PacientWaitListAdapter.ViewHolder holder, int position) {
        holder.id.setText(dataSet.get(position)._id);
        holder.name.setText(dataSet.get(position).name);
        holder.container.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                callback.goToVideoConference();
            }
        });
    }

    @Override
    public int getItemCount() {
        return dataSet.size();
    }
}
