package com.acabezas.ehealth_doctor_app.home.pacient_waiting_fragment;

import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.support.v7.widget.LinearLayoutManager;
import android.support.v7.widget.RecyclerView;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;

import com.acabezas.ehealth_doctor_app.R;
import com.acabezas.ehealth_doctor_app.core.StartVideoConferenceCallback;
import com.acabezas.ehealth_doctor_app.home.scheduled_appointments_fragment.ScheduledAppointmentsAdapter;
import com.acabezas.ehealth_doctor_sdk.DoctorAPImpl;
import com.acabezas.ehealth_doctor_sdk.callbacks.GetPAcientWaitingListCallback;
import com.acabezas.ehealth_doctor_sdk.callbacks.GetScheduledAppointmentsCallback;
import com.acabezas.ehealth_doctor_sdk.managers.SharedPreferencesManager;
import com.acabezas.ehealth_doctor_sdk.managers.SharedPreferencesManagerImpl;
import com.acabezas.ehealth_doctor_sdk.model.GetAppointmentListRequest;
import com.acabezas.ehealth_doctor_sdk.model.PacientWaiting;
import com.acabezas.ehealth_doctor_sdk.model.ScheduledAppointmentData;

import java.util.ArrayList;
import java.util.List;

/**
 * Created by alexandercabezas on 12/5/18.
 */

public class PacientWaitingFragment extends Fragment {

    private RecyclerView recyclerView;
    private RecyclerView.Adapter adapter;
    private RecyclerView.LayoutManager layoutManager;
    private List<PacientWaiting> data;
    private SharedPreferencesManager sharedPreferencesManager;
    private StartVideoConferenceCallback callback;

    public PacientWaitingFragment() {
        // Required empty public constructor
    }

    public void setCallback(StartVideoConferenceCallback callback) {
        this.callback = callback;
    }

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {

        View view = inflater.inflate(R.layout.pacient_waiting_list_fragment, container, false);
        recyclerView = (RecyclerView)view.findViewById(R.id.appointment_list);

        data = new ArrayList<>();
        adapter = new PacientWaitListAdapter(data, callback);
        // use this setting to improve performance if you know that changes
        // in content do not change the layout size of the RecyclerView
        recyclerView.setHasFixedSize(true);

        // use a linear layout manager
        layoutManager = new LinearLayoutManager(getActivity());
        recyclerView.setLayoutManager(layoutManager);

        // specify an adapter (see also next example)
        //adapter = new ScheduledAppointmentsAdapter(List< ScheduledAppointmentData>);
        recyclerView.setAdapter(adapter);

        DoctorAPImpl.getInstance().getPacientWaitingList(new GetPAcientWaitingListCallback() {

            @Override
            public void success(List<PacientWaiting> dataResult) {
                data.addAll(dataResult);
                adapter.notifyDataSetChanged();
            }

            @Override
            public void failure() {
                int a =0;
            }
        });

        // Inflate the layout for this fragment
        return view;
    }
}
