package com.acabezas.ehealth_doctor_app.home.scheduled_appointments_fragment;

import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.support.v7.widget.LinearLayoutManager;
import android.support.v7.widget.RecyclerView;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;

import com.acabezas.ehealth_doctor_app.R;
import com.acabezas.ehealth_doctor_sdk.DoctorAPImpl;
import com.acabezas.ehealth_doctor_sdk.callbacks.GetScheduledAppointmentsCallback;
import com.acabezas.ehealth_doctor_sdk.managers.SharedPreferencesManager;
import com.acabezas.ehealth_doctor_sdk.managers.SharedPreferencesManagerImpl;
import com.acabezas.ehealth_doctor_sdk.model.GetAppointmentListRequest;
import com.acabezas.ehealth_doctor_sdk.model.ScheduledAppointmentData;

import java.util.ArrayList;
import java.util.List;

/**
 * Created by alexandercabezas on 12/5/18.
 */

public class ScheduledAppointmentsFragment extends Fragment {

    private RecyclerView recyclerView;
    private RecyclerView.Adapter adapter;
    private RecyclerView.LayoutManager layoutManager;
    private List<ScheduledAppointmentData> data;
    private SharedPreferencesManager sharedPreferencesManager;

    public ScheduledAppointmentsFragment() {
        // Required empty public constructor
    }

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {

        View view = inflater.inflate(R.layout.scheduled_appointments_fragment, container, false);
        recyclerView = (RecyclerView)view.findViewById(R.id.appointment_list);

        data = new ArrayList<>();
        adapter = new ScheduledAppointmentsAdapter(data);
        // use this setting to improve performance if you know that changes
        // in content do not change the layout size of the RecyclerView
        recyclerView.setHasFixedSize(true);

        // use a linear layout manager
        layoutManager = new LinearLayoutManager(getActivity());
        recyclerView.setLayoutManager(layoutManager);

        // specify an adapter (see also next example)
        //adapter = new ScheduledAppointmentsAdapter(List< ScheduledAppointmentData>);
        recyclerView.setAdapter(adapter);

        GetAppointmentListRequest request = new GetAppointmentListRequest();
        sharedPreferencesManager = SharedPreferencesManagerImpl.getInstance(getActivity().getApplicationContext());
        request.user = sharedPreferencesManager.getUserId();
        DoctorAPImpl.getInstance().getScheduledAppointments(request,new GetScheduledAppointmentsCallback() {
            @Override
            public void success(List<ScheduledAppointmentData> dataResult) {
                data.addAll(dataResult);
                adapter.notifyDataSetChanged();
            }

            @Override
            public void failure() {
                int a =0;
            }
        });

        // Inflate the layout for this fragment
        return view;
    }
}
