package com.acabezas.ehealth_doctor_app.login;

import com.acabezas.ehealth_doctor_sdk.DoctorAPImpl;
import com.acabezas.ehealth_doctor_sdk.callbacks.LoginDoctorCallback;
import com.acabezas.ehealth_doctor_sdk.managers.SharedPreferencesManager;
import com.acabezas.ehealth_doctor_sdk.model.LoginRequest;
import com.acabezas.ehealth_doctor_sdk.model.LoginResponse;

/**
 * Created by alexandercabezas on 11/4/18.
 */

public class LoginInteractor implements LoginContracts.Interactor{

    private LoginContracts.InteractorOutput output;
    private SharedPreferencesManager sharedPreferencesManager;

    public LoginInteractor(LoginContracts.InteractorOutput output,
                           SharedPreferencesManager sharedPreferencesManager) {
        this.output = output;
        this.sharedPreferencesManager = sharedPreferencesManager;
    }

    @Override
    public void unRegister() {
        output = null;
    }

    @Override
    public void doLogin(LoginRequest request) {

        DoctorAPImpl.getInstance().loginDoctor(request, new LoginDoctorCallback() {
            @Override
            public void success(LoginResponse response) {
                sharedPreferencesManager.saveUserId(response._id);
                output.loginSuccess();
            }

            @Override
            public void failure() {
                output.loginFailed();
            }
        });

    }
}
