package com.acabezas.ehealth_doctor_app.login;

import android.app.Activity;

import com.acabezas.ehealth_doctor_app.tools.Tools;
import com.acabezas.ehealth_doctor_sdk.managers.SharedPreferencesManager;
import com.acabezas.ehealth_doctor_sdk.model.LoginRequest;

/**
 * Created by alexandercabezas on 11/4/18.
 */

public class LoginPresenter implements LoginContracts.Presenter, LoginContracts.InteractorOutput{

    private LoginContracts.Interactor interactor;
    private LoginContracts.Router router;
    private LoginContracts.View view;

    LoginPresenter(LoginContracts.View view,SharedPreferencesManager sharedPreferencesManager) {
        interactor = new LoginInteractor(this, sharedPreferencesManager);
        router = new LoginRouter((Activity) view);
        this.view = view;
    }
    @Override
    public void onDestroy() {
        view = null;
        interactor.unRegister();
        interactor = null;
        router.unRegister();
        router = null;
    }

    @Override
    public void goToHomeScreen() {

    }

    @Override
    public void goToRegisterScreen() {
        router.presentRegisterScreen();
    }

    @Override
    public void goToRecoverPasswordScreen() {
        router.presentRecoverPasswordScreen();
    }

    @Override
    public void doLogin(String username, String password) {
        if(Tools.isValidEmail(username)) {
            if( !password.isEmpty()) {
                LoginRequest request = new LoginRequest();
                request.email = username;
                request.password = password;
                interactor.doLogin(request);
            } else {
                view.showError(1);
            }

        } else {
            view.showError(2);
        }

    }

    @Override
    public void loginSuccess() {
        router.presentHomeScreen();
    }

    @Override
    public void loginFailed() {
        view.showError(1);
    }
}
