package com.acabezas.ehealth_doctor_app.my_account;

import com.acabezas.ehealth_doctor_sdk.model.UpdateProfileRequest;

/**
 * Created by alexandercabezas on 3/5/18.
 */

public class MyAccountContracts {

    interface View {
        void onDestroy();
        void showError(int error);
        void showSuccess();
        void showUserData(String name,
                          String lastname1,
                          String lastname2,
                          String email,
                          String specialty,
                          String dateOfBirth,
                          String password);
    }

    interface Presenter {
        void onDestroy();
        void goToHomeScreen();
        void doUpdate(String name,
                      String lastname1,
                      String lastname2,
                      String email,
                      String specialty,
                      String dateOfBirth,
                      String password);
        void getData();
    }

    interface Interactor {
        void unRegister();
        void doUpdate(UpdateProfileRequest request);
        void getData();
    }

    interface InteractorOutput {
        void updateSuccess();
        void updateFailed();
        void getDataSuccess(UpdateProfileRequest response);
        void getDataFailed();
    }


    interface Router {
        void unRegister();
        void presentHomeScreen();
    }
}
