package com.acabezas.ehealth_doctor_app.my_account;

import com.acabezas.ehealth_doctor_sdk.DoctorAPImpl;
import com.acabezas.ehealth_doctor_sdk.callbacks.GetUserProfileDataCallback;
import com.acabezas.ehealth_doctor_sdk.callbacks.UpdateUserProfileDataCallback;
import com.acabezas.ehealth_doctor_sdk.managers.SharedPreferencesManager;
import com.acabezas.ehealth_doctor_sdk.model.UpdateProfileRequest;

/**
 * Created by alexandercabezas on 3/5/18.
 */

public class MyAccountInteractor implements MyAccountContracts.Interactor{
    private MyAccountContracts.InteractorOutput output;
    private SharedPreferencesManager sharedPreferencesManager;

    public MyAccountInteractor(MyAccountContracts.InteractorOutput output,
                               SharedPreferencesManager sharedPreferencesManager) {
        this.output = output;
        this.sharedPreferencesManager = sharedPreferencesManager;
    }

    @Override
    public void unRegister() {
        output = null;
    }

    @Override
    public void doUpdate(UpdateProfileRequest request) {
        request._id =  sharedPreferencesManager.getUserId();
        DoctorAPImpl.getInstance().updateDoctorProfileData(request, new UpdateUserProfileDataCallback() {
            @Override
            public void success() {
                output.updateSuccess();
            }

            @Override
            public void failure() {
                output.updateFailed();
            }
        });
    }

    @Override
    public void getData() {
        String user = sharedPreferencesManager.getUserId();
        DoctorAPImpl.getInstance().getDoctorData(user, new GetUserProfileDataCallback() {
            @Override
            public void success(UpdateProfileRequest response) {
                output.getDataSuccess(response);
            }

            @Override
            public void failure() {
                output.getDataFailed();
            }
        });
    }
}
