package com.acabezas.ehealth_doctor_app.my_account;

import android.app.Activity;

import com.acabezas.ehealth_doctor_sdk.managers.SharedPreferencesManager;
import com.acabezas.ehealth_doctor_sdk.model.UpdateProfileRequest;

/**
 * Created by alexandercabezas on 3/5/18.
 */

public class MyAccountPresenter implements MyAccountContracts.Presenter, MyAccountContracts.InteractorOutput {
    private MyAccountContracts.Interactor interactor;
    private MyAccountContracts.Router router;
    private MyAccountContracts.View view;

    MyAccountPresenter(MyAccountContracts.View view,SharedPreferencesManager sharedPreferencesManager) {
        interactor = new MyAccountInteractor(this, sharedPreferencesManager);
        router = new MyAccountRouter((Activity) view);
        this.view = view;
    }

    @Override
    public void onDestroy() {
        view = null;
        interactor.unRegister();
        interactor = null;
        router.unRegister();
        router = null;
    }

    @Override
    public void goToHomeScreen() {

    }

    @Override
    public void doUpdate(String name,
                         String lastname1,
                         String lastname2,
                         String email,
                         String specialty,
                         String dateOfBirth,
                         String password) {

        if(!name.isEmpty() &&
                !lastname1.isEmpty() &&
                !lastname2.isEmpty() &&
                !email.isEmpty() &&
                !specialty.isEmpty() &&
                !dateOfBirth.isEmpty() &&
                !password.isEmpty()) {

            //TODO: checj date higher than today
            if(!dateOfBirth.isEmpty()) {
                UpdateProfileRequest request = new UpdateProfileRequest();
                request.name = name;
                request.lastname1 = lastname1;
                request.lastname2 = lastname2;
                request.email = email;
                request.specialty = specialty;
                request.dateOfBirth = dateOfBirth;
                request.password = password;

                interactor.doUpdate(request);
            } else {view.showError(2);}

        } else {
            view.showError(3);
        }


    }

    @Override
    public void getData() {
        interactor.getData();
    }

    @Override
    public void updateSuccess() {
        view.showSuccess();
    }

    @Override
    public void updateFailed() {
        view.showError(1);
    }

    @Override
    public void getDataSuccess(UpdateProfileRequest response) {
        view.showUserData(response.name,
                response.lastname1,
                response.lastname2,
                response.email,
                response.specialty,
                response.dateOfBirth,
                response.password);
    }

    @Override
    public void getDataFailed() {
        view.showError(1);
    }
}
