package com.acabezas.ehealth_doctor_app.recover_password;

import com.acabezas.ehealth_doctor_sdk.DoctorAPImpl;
import com.acabezas.ehealth_doctor_sdk.callbacks.RecoverPasswordCallback;
import com.acabezas.ehealth_doctor_sdk.model.RecoverPasswordRequest;

/**
 * Created by alexandercabezas on 14/4/18.
 */

public class RecoverPasswordInteractor implements RecoverPasswordContracts.Interactor{
    private RecoverPasswordContracts.InteractorOutput output;

    public RecoverPasswordInteractor(RecoverPasswordContracts.InteractorOutput output) {
        this.output = output;
    }

    @Override
    public void unRegister() {
        output = null;
    }

    @Override
    public void recoverPassword(RecoverPasswordRequest request) {

        DoctorAPImpl.getInstance().recoverPassword(request, new RecoverPasswordCallback() {
            @Override
            public void success() {
                output.recoverPasswordSuccess();
            }

            @Override
            public void failure() {
                output.recoverPasswordFailed();
            }
        });

    }
}
