package com.acabezas.ehealth_doctor_app.registration;

import com.acabezas.ehealth_doctor_sdk.DoctorAPImpl;
import com.acabezas.ehealth_doctor_sdk.callbacks.SignUpDoctorCallback;
import com.acabezas.ehealth_doctor_sdk.managers.SharedPreferencesManager;
import com.acabezas.ehealth_doctor_sdk.model.SignUpRequest;
import com.acabezas.ehealth_doctor_sdk.model.SignUpResponse;

/**
 * Created by alexandercabezas on 14/4/18.
 */

public class SignUpInteractor implements SignUpContracts.Interactor{

    private SignUpContracts.InteractorOutput output;
    private SharedPreferencesManager sharedPreferencesManager;

    public SignUpInteractor(SignUpContracts.InteractorOutput output,
                            SharedPreferencesManager sharedPreferencesManager) {
        this.output = output;
        this.sharedPreferencesManager = sharedPreferencesManager;
    }

    @Override
    public void unRegister() {
        output = null;
    }

    @Override
    public void doSignUp(SignUpRequest request) {
        DoctorAPImpl.getInstance().signUpDoctor(request, new SignUpDoctorCallback() {
            @Override
            public void success(SignUpResponse response) {
                sharedPreferencesManager.saveUserId(response._id);
                output.sigUpSuccess();
            }

            @Override
            public void failure() {
                output.signUpFailed();
            }
        });
    }
}
