package com.acabezas.ehealth_doctor_app.video_conference;

/**
 * Created by alexandercabezas on 14/4/18.
 */

public class VideoConferenceContracts {

    interface View {
        void onDestroy();
        void showError();
        void startVideoConference();
    }

    interface Presenter {
        void onDestroy();
        void goToHomeScreen();
        void goToRateScreen();
        void addUserToWaitList();
        void startVideoConference();
        void cancelVideoconference();
    }

    interface Interactor {
        void unRegister();
        void addUserToWaitList();
        void startVideoConference();
        void cancelVideoconference();
    }

    interface InteractorOutput {
        void addUserToWaitListSuccess();
        void addUserToWaitListFailed();
    }


    interface Router {
        void unRegister();
        void presentHomeScreen();
        void presentRateScreen();
    }
}
