package com.acabezas.ehealth_doctor_app.video_conference;

import android.app.Activity;

import com.acabezas.ehealth_doctor_sdk.managers.SharedPreferencesManager;

/**
 * Created by alexandercabezas on 14/4/18.
 */

public class VideoConferencePresenter implements VideoConferenceContracts.Presenter, VideoConferenceContracts.InteractorOutput{
    private VideoConferenceContracts.Interactor interactor;
    private VideoConferenceContracts.Router router;
    private VideoConferenceContracts.View view;

    VideoConferencePresenter(VideoConferenceContracts.View view, SharedPreferencesManager sharedPreferencesManager) {
        interactor = new VideoConferenceInteractor(this, sharedPreferencesManager);
        router = new VideoConferenceRouter((Activity) view);
        this.view = view;
    }
    @Override
    public void onDestroy() {
        interactor.unRegister();
        interactor = null;
        router.unRegister();
        router = null;
    }

    @Override
    public void goToHomeScreen() {
        router.presentHomeScreen();
    }

    @Override
    public void goToRateScreen() {
        router.presentRateScreen();
    }

    @Override
    public void addUserToWaitList() {
        interactor.addUserToWaitList();
    }

    @Override
    public void startVideoConference() {

    }

    @Override
    public void cancelVideoconference() {
        interactor.cancelVideoconference();
    }

    @Override
    public void addUserToWaitListSuccess() {
        view.startVideoConference();
    }

    @Override
    public void addUserToWaitListFailed() {
        view.showError();
    }
}
