package com.acabezas.ehealth_doctor_sdk;


import com.acabezas.ehealth_doctor_sdk.callbacks.GetPAcientWaitingListCallback;
import com.acabezas.ehealth_doctor_sdk.callbacks.GetScheduledAppointmentsCallback;
import com.acabezas.ehealth_doctor_sdk.callbacks.GetUserProfileDataCallback;
import com.acabezas.ehealth_doctor_sdk.callbacks.LoginDoctorCallback;
import com.acabezas.ehealth_doctor_sdk.callbacks.RecoverPasswordCallback;
import com.acabezas.ehealth_doctor_sdk.callbacks.SignUpDoctorCallback;
import com.acabezas.ehealth_doctor_sdk.callbacks.UpdateUserProfileDataCallback;
import com.acabezas.ehealth_doctor_sdk.model.GetAppointmentListRequest;
import com.acabezas.ehealth_doctor_sdk.model.GetPacientWaitListResponse;
import com.acabezas.ehealth_doctor_sdk.model.LoginRequest;
import com.acabezas.ehealth_doctor_sdk.model.RecoverPasswordRequest;
import com.acabezas.ehealth_doctor_sdk.model.RemoveUserFromWaitListRequest;
import com.acabezas.ehealth_doctor_sdk.model.SignUpRequest;
import com.acabezas.ehealth_doctor_sdk.model.UpdateProfileRequest;

/**
 * Created by alexandercabezas on 16/4/18.
 */

public interface DoctorAPI {

    void signUpDoctor(SignUpRequest request, SignUpDoctorCallback callback);

    void loginDoctor(LoginRequest request, LoginDoctorCallback callback);

    void recoverPassword(RecoverPasswordRequest request, RecoverPasswordCallback callback);

    void getScheduledAppointments(GetAppointmentListRequest request, GetScheduledAppointmentsCallback callback);

    void getDoctorData(String user, GetUserProfileDataCallback callback);

    void updateDoctorProfileData(UpdateProfileRequest request, UpdateUserProfileDataCallback callback);

    void removePacientfromWaitList(RemoveUserFromWaitListRequest removeUserFromWaitListRequest);

    void getPacientWaitingList(GetPAcientWaitingListCallback callback);
}
