package com.acabezas.ehealth_doctor_sdk;


import com.acabezas.ehealth_doctor_sdk.callbacks.GetPAcientWaitingListCallback;
import com.acabezas.ehealth_doctor_sdk.callbacks.GetScheduledAppointmentsCallback;
import com.acabezas.ehealth_doctor_sdk.callbacks.GetUserProfileDataCallback;
import com.acabezas.ehealth_doctor_sdk.callbacks.LoginDoctorCallback;
import com.acabezas.ehealth_doctor_sdk.callbacks.RecoverPasswordCallback;
import com.acabezas.ehealth_doctor_sdk.callbacks.SignUpDoctorCallback;
import com.acabezas.ehealth_doctor_sdk.callbacks.UpdateUserProfileDataCallback;
import com.acabezas.ehealth_doctor_sdk.model.GetAppointmentListRequest;
import com.acabezas.ehealth_doctor_sdk.model.LoginRequest;
import com.acabezas.ehealth_doctor_sdk.model.RecoverPasswordRequest;
import com.acabezas.ehealth_doctor_sdk.model.RemoveUserFromWaitListRequest;
import com.acabezas.ehealth_doctor_sdk.model.SignUpRequest;
import com.acabezas.ehealth_doctor_sdk.model.UpdateProfileRequest;
import com.acabezas.ehealth_doctor_sdk.repository.DoctorDataRepository;

/**
 * Created by alexandercabezas on 16/4/18.
 */

public class DoctorAPImpl implements DoctorAPI{

    private static DoctorAPI mDoctor;

    private DoctorAPImpl() {
    }

    public static DoctorAPI getInstance() {

        if (mDoctor == null) {
            mDoctor = new DoctorAPImpl();
        }

        return mDoctor;

    }


    @Override
    public void signUpDoctor(SignUpRequest request, SignUpDoctorCallback callback) {
        DoctorDataRepository.getInstance().signUpDoctor(request, callback);
    }

    @Override
    public void loginDoctor(LoginRequest request, LoginDoctorCallback callback) {
        DoctorDataRepository.getInstance().loginDoctor(request, callback);
    }

    @Override
    public void recoverPassword(RecoverPasswordRequest request, RecoverPasswordCallback callback) {
        DoctorDataRepository.getInstance().recoverPassword(request, callback);
    }

    @Override
    public void getScheduledAppointments(GetAppointmentListRequest request, GetScheduledAppointmentsCallback callback) {
        DoctorDataRepository.getInstance().getScheduledAppointments(request, callback);
    }

    @Override
    public void getDoctorData(String user, GetUserProfileDataCallback callback) {
        DoctorDataRepository.getInstance().getDoctorData(user, callback);
    }

    @Override
    public void updateDoctorProfileData(UpdateProfileRequest request, UpdateUserProfileDataCallback callback) {
        DoctorDataRepository.getInstance().updateDoctorProfileData(request, callback);
    }

    @Override
    public void removePacientfromWaitList(RemoveUserFromWaitListRequest removeUserFromWaitListRequest) {
        DoctorDataRepository.getInstance().removePacientfromWaitList(removeUserFromWaitListRequest);
    }

    @Override
    public void getPacientWaitingList(GetPAcientWaitingListCallback callback) {
        DoctorDataRepository.getInstance().getPacientWaitingList(callback);
    }
}
