package com.acabezas.ehealth_doctor_sdk.factory;


import com.acabezas.ehealth_doctor_sdk.BuildConfig;
import com.acabezas.ehealth_doctor_sdk.data_source.DoctorDataSource;
import com.acabezas.ehealth_doctor_sdk.data_source.LocalDataSource;
import com.acabezas.ehealth_doctor_sdk.data_source.RemoteDataSource;

/**
 * Created by alexandercabezas on 16/4/18.
 */

public class DoctorDataFactory {

    private static LocalDataSource sLocalDataSource;
    private static RemoteDataSource sRemoteDataSource;

    public static DoctorDataSource create() {

        if (BuildConfig.FLAVOR.equals("mock")) {

            if (sLocalDataSource == null) {
                sLocalDataSource = new LocalDataSource();
            }

            return sLocalDataSource;

        } else {
            if (sRemoteDataSource == null) {
                sRemoteDataSource = new RemoteDataSource();
            }

            return sRemoteDataSource;
        }
    }
}
