package com.acabezas.ehealth_doctor_sdk.managers;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;

import okhttp3.OkHttpClient;
import okhttp3.logging.HttpLoggingInterceptor;
import retrofit2.Retrofit;
import retrofit2.converter.gson.GsonConverterFactory;

/**
 * Created by alexandercabezas on 8/5/18.
 */

public class NetworkManagerImpl implements NetworkManager {
    private static NetworkManager sNetworkManager;
    private Retrofit mRetrofit;

    private NetworkManagerImpl() {
        //This only exists to defeat instantiation
    }

    public static synchronized NetworkManager getInstance() {
        if (sNetworkManager == null) {
            sNetworkManager = new NetworkManagerImpl();
        }

        return sNetworkManager;
    }

    @Override
    public Retrofit getRetrofitInstance() {
        if (mRetrofit == null) {
            HttpLoggingInterceptor logging = new HttpLoggingInterceptor();
            logging.setLevel(HttpLoggingInterceptor.Level.BODY);

            OkHttpClient.Builder client = new OkHttpClient.Builder();

            Gson gson = new GsonBuilder()
                    .setDateFormat("yyyy-MM-dd'T'HH:mm:ss.SSSZ")
                    .create();

            mRetrofit = new Retrofit.Builder().client(client.addInterceptor(logging).build())
                    //.baseUrl("http://10.0.2.2:4000/")
                    .baseUrl("https://aqueous-woodland-70666.herokuapp.com/")
                    //.baseUrl("http://165.227.102.101:4000/")
                    .addConverterFactory(GsonConverterFactory.create(gson))
                    .build();
        }

        return mRetrofit;
    }
}
