package com.acabezas.ehealth_doctor_sdk.managers;

import android.content.Context;
import android.content.SharedPreferences;

import static android.content.Context.MODE_PRIVATE;

/**
 * Created by alexandercabezas on 8/5/18.
 */

public class SharedPreferencesManagerImpl implements SharedPreferencesManager {

    private static SharedPreferencesManager sharedPrefManager;
    private Context context;
    private static final String MY_PREFS_NAME = "MyPrefsFile";
    private static final String USER_KEY = "_id";

    private SharedPreferencesManagerImpl(Context context) {
        //This only exists to defeat instantiation
        this.context = context;
    }

    public static synchronized SharedPreferencesManager getInstance(Context context) {
        if (sharedPrefManager == null) {
            sharedPrefManager = new SharedPreferencesManagerImpl(context);
        }

        return sharedPrefManager;
    }

    @Override
    public void saveUserId(String userId) {

        SharedPreferences.Editor editor = context.getSharedPreferences(MY_PREFS_NAME, MODE_PRIVATE).edit();
        editor.putString(USER_KEY, userId);
        editor.apply();
    }

    @Override
    public String getUserId() {

        SharedPreferences prefs = context.getSharedPreferences(MY_PREFS_NAME, MODE_PRIVATE);
        String restoredUser = prefs.getString(USER_KEY, null);
        return restoredUser;
    }
}
