package com.acabezas.ehealth_doctor_sdk.repository;

import com.acabezas.ehealth_doctor_sdk.callbacks.GetPAcientWaitingListCallback;
import com.acabezas.ehealth_doctor_sdk.callbacks.GetScheduledAppointmentsCallback;
import com.acabezas.ehealth_doctor_sdk.callbacks.GetUserProfileDataCallback;
import com.acabezas.ehealth_doctor_sdk.callbacks.LoginDoctorCallback;
import com.acabezas.ehealth_doctor_sdk.callbacks.RecoverPasswordCallback;
import com.acabezas.ehealth_doctor_sdk.callbacks.SignUpDoctorCallback;
import com.acabezas.ehealth_doctor_sdk.callbacks.UpdateUserProfileDataCallback;
import com.acabezas.ehealth_doctor_sdk.data_source.DoctorDataSource;
import com.acabezas.ehealth_doctor_sdk.factory.DoctorDataFactory;
import com.acabezas.ehealth_doctor_sdk.model.GetAppointmentListRequest;
import com.acabezas.ehealth_doctor_sdk.model.LoginRequest;
import com.acabezas.ehealth_doctor_sdk.model.RecoverPasswordRequest;
import com.acabezas.ehealth_doctor_sdk.model.RemoveUserFromWaitListRequest;
import com.acabezas.ehealth_doctor_sdk.model.SignUpRequest;
import com.acabezas.ehealth_doctor_sdk.model.UpdateProfileRequest;

/**
 * Created by alexandercabezas on 16/4/18.
 */

public class DoctorDataRepository implements DoctorRepository {

    private static DoctorDataRepository sRepository;

    private DoctorDataRepository() {
    }

    public static DoctorRepository getInstance() {
        if (sRepository == null) {
            sRepository = new DoctorDataRepository();
        }

        return sRepository;
    }

    @Override
    public void signUpDoctor(SignUpRequest request, SignUpDoctorCallback callback) {
        DoctorDataSource pacientDataStore = DoctorDataFactory.create();
        pacientDataStore.signUpDoctor(request, callback);
    }

    @Override
    public void loginDoctor(LoginRequest request, LoginDoctorCallback callback) {
        DoctorDataSource pacientDataStore = DoctorDataFactory.create();
        pacientDataStore.loginDoctor(request, callback);
    }

    @Override
    public void recoverPassword(RecoverPasswordRequest request, RecoverPasswordCallback callback) {
        DoctorDataSource pacientDataStore = DoctorDataFactory.create();
        pacientDataStore.recoverPassword(request, callback);
    }


    @Override
    public void getScheduledAppointments(GetAppointmentListRequest request, GetScheduledAppointmentsCallback callback) {
        DoctorDataSource pacientDataStore = DoctorDataFactory.create();
        pacientDataStore.getScheduledAppointments(request, callback);
    }

    @Override
    public void getDoctorData(String user, GetUserProfileDataCallback callback) {
        DoctorDataSource pacientDataStore = DoctorDataFactory.create();
        pacientDataStore.getDoctorData(user, callback);
    }

    @Override
    public void updateDoctorProfileData(UpdateProfileRequest request, UpdateUserProfileDataCallback callback) {
        DoctorDataSource pacientDataStore = DoctorDataFactory.create();
        pacientDataStore.updateDoctorProfileData(request, callback);
    }


    @Override
    public void removePacientfromWaitList(RemoveUserFromWaitListRequest removeUserFromWaitListRequest) {
        DoctorDataSource pacientDataStore = DoctorDataFactory.create();
        pacientDataStore.removePacientfromWaitList(removeUserFromWaitListRequest);
    }

    @Override
    public void getPacientWaitingList(GetPAcientWaitingListCallback callback) {
        DoctorDataSource pacientDataStore = DoctorDataFactory.create();
        pacientDataStore.getPacientWaitingList( callback);

    }
}
